package fr.irisa.cairn.jnimap.generator.java;

import com.google.common.base.Objects;
import fr.irisa.cairn.jniMap.BooleanType;
import fr.irisa.cairn.jniMap.ClassMapping;
import fr.irisa.cairn.jniMap.Mapping;
import fr.irisa.cairn.jniMap.Method;
import fr.irisa.cairn.jniMap.ParamDef;
import fr.irisa.cairn.jnimap.generator.CommonExtensions;
import fr.irisa.cairn.jnimap.generator.TypeExtensions;
import fr.irisa.cairn.jnimap.generator.java.JNIJavaUtilities;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

@SuppressWarnings("all")
public abstract class AbstractWrapper {
  @Extension
  private CommonExtensions _commonExtensions = new CommonExtensions();
  
  @Extension
  private TypeExtensions _typeExtensions = new TypeExtensions();
  
  @Extension
  private JNIJavaUtilities _jNIJavaUtilities = new JNIJavaUtilities();
  
  public CharSequence javaMethodName(final Method method) {
    StringConcatenation _builder = new StringConcatenation();
    String _methodName = this._typeExtensions.getMethodName(method);
    _builder.append(_methodName);
    return _builder;
  }
  
  public CharSequence classType(final ClassMapping cm) {
    CharSequence _xifexpression = null;
    boolean _isInterface = this._jNIJavaUtilities.isInterface(cm);
    if (_isInterface) {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("interface");
      _xifexpression = _builder;
    } else {
      CharSequence _xifexpression_1 = null;
      boolean _isAbstract = this._jNIJavaUtilities.isAbstract(cm);
      if (_isAbstract) {
        StringConcatenation _builder_1 = new StringConcatenation();
        _builder_1.append("abstract class");
        _xifexpression_1 = _builder_1;
      } else {
        StringConcatenation _builder_2 = new StringConcatenation();
        _builder_2.append("class");
        _xifexpression_1 = _builder_2;
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
  
  public CharSequence inheritanceDecl(final ClassMapping cm, final Mapping m) {
    CharSequence _xifexpression = null;
    if ((this._jNIJavaUtilities.isInterface(cm) && this._jNIJavaUtilities.javaSuperClass(cm, m).contentEquals("JNIObject"))) {
      StringConcatenation _builder = new StringConcatenation();
      _xifexpression = _builder;
    } else {
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("extends ");
      String _javaSuperClass = this._jNIJavaUtilities.javaSuperClass(cm, m);
      _builder_1.append(_javaSuperClass);
      _xifexpression = _builder_1;
    }
    return _xifexpression;
  }
  
  public CharSequence classMappingContent(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = this._commonExtensions.packageName(m);
    _builder.append(_packageName);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _imports = this.imports(cm, m);
    _builder.append(_imports);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("/*** PROTECTED REGION ID(");
    String _name = cm.getName();
    _builder.append(_name);
    _builder.append("_userImport) ENABLED START ***/");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("/*");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("Put you custom import here ....");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("/*** PROTECTED REGION END ***/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*  Automatically generated by jnimap ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("public ");
    CharSequence _classType = this.classType(cm);
    _builder.append(_classType);
    _builder.append(" ");
    CharSequence _javaClassName = this._jNIJavaUtilities.javaClassName(cm);
    _builder.append(_javaClassName);
    CharSequence _genericsDeclarations = this._jNIJavaUtilities.genericsDeclarations(cm);
    _builder.append(_genericsDeclarations);
    _builder.append(" ");
    CharSequence _inheritanceDecl = this.inheritanceDecl(cm, m);
    _builder.append(_inheritanceDecl);
    _builder.append(" ");
    CharSequence _interfaceImplementations = this._jNIJavaUtilities.interfaceImplementations(cm, m);
    _builder.append(_interfaceImplementations);
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _nativePointerManagement = this.nativePointerManagement(cm, m);
    _builder.append(_nativePointerManagement, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("/*** PROTECTED REGION ID(");
    String _name_1 = cm.getName();
    _builder.append(_name_1, "\t");
    _builder.append("_userCode) ENABLED START ***/");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("/*** PROTECTED REGION END ***/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    CharSequence _specializedBody = this.specializedBody(cm, m);
    _builder.append(_specializedBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _staticMethodBodies = this.staticMethodBodies(cm, m);
    _builder.append(_staticMethodBodies, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _memberMethodBodies = this.memberMethodBodies(cm, m);
    _builder.append(_memberMethodBodies, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _stringBody = this.toStringBody(cm, m);
    _builder.append(_stringBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence imports(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("import java.util.AbstractMap;");
    _builder.newLine();
    _builder.append("import java.util.ArrayList;");
    _builder.newLine();
    _builder.append("import java.util.HashMap;");
    _builder.newLine();
    _builder.append("import java.util.LinkedHashMap;");
    _builder.newLine();
    _builder.append("import java.util.List;");
    _builder.newLine();
    _builder.append("import java.util.Map;");
    _builder.newLine();
    _builder.append("import java.util.Map.Entry;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import fr.irisa.cairn.jnimap.runtime.JNIObject;");
    _builder.newLine();
    _builder.newLine();
    CharSequence _importSuperClass = this.importSuperClass(cm, m);
    _builder.append(_importSuperClass);
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence importSuperClass(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    return _builder;
  }
  
  public CharSequence nativePointerManagement(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isInterface = this._jNIJavaUtilities.isInterface(cm);
      boolean _not = (!_isInterface);
      if (_not) {
        _builder.append("/* @generated */");
        _builder.newLine();
        _builder.append("protected ");
        CharSequence _javaClassName = this._jNIJavaUtilities.javaClassName(cm);
        _builder.append(_javaClassName);
        _builder.append("(long ptr) {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION ID(");
        String _name = cm.getName();
        _builder.append(_name, "\t");
        _builder.append("_Constructor) DISABLED START ***/");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("super(ptr);");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION END ***/");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
        _builder.newLine();
        _builder.append("/* @generated */");
        _builder.newLine();
        _builder.append("protected static ");
        CharSequence _javaClassName_1 = this._jNIJavaUtilities.javaClassName(cm);
        _builder.append(_javaClassName_1);
        _builder.append(" build(long ptr) {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("return new ");
        CharSequence _javaClassName_2 = this._jNIJavaUtilities.javaClassName(cm);
        _builder.append(_javaClassName_2, "\t");
        _builder.append("(ptr);");
        _builder.newLineIfNotEmpty();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  public CharSequence specializedBody(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    return _builder;
  }
  
  public CharSequence staticMethodBodies(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/*************************************** ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*\t         Static Methods            * ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("***************************************/");
    _builder.newLine();
    {
      Iterable<Method> _staticMethods = this._typeExtensions.staticMethods(this._commonExtensions.getMethodGroup(cm, m));
      for(final Method method : _staticMethods) {
        final Function1<ParamDef, Boolean> _function = (ParamDef p) -> {
          return Boolean.valueOf(p.isTake());
        };
        final Iterable<ParamDef> takeList = IterableExtensions.<ParamDef>filter(this._commonExtensions.getActiveParams(method), _function);
        _builder.newLineIfNotEmpty();
        _builder.append("/**");
        _builder.newLine();
        _builder.append(" ");
        _builder.append("* ");
        String _name = method.getName();
        _builder.append(_name, " ");
        _builder.append(" ");
        _builder.newLineIfNotEmpty();
        _builder.append(" ");
        _builder.append("* ");
        _builder.newLine();
        {
          boolean _isEmpty = IterableExtensions.isEmpty(takeList);
          boolean _not = (!_isEmpty);
          if (_not) {
            _builder.append("@take ");
            final Function1<ParamDef, CharSequence> _function_1 = (ParamDef p) -> {
              return p.getName();
            };
            String _join = IterableExtensions.<ParamDef>join(takeList, " ", _function_1);
            _builder.append(_join);
          }
        }
        _builder.newLineIfNotEmpty();
        _builder.append(" ");
        _builder.append("* @generated");
        _builder.newLine();
        _builder.append("**/");
        _builder.newLine();
        _builder.append(" ");
        String _visibility = this._commonExtensions.visibility(method);
        _builder.append(_visibility, " ");
        _builder.append(" static ");
        String _returnTypeStandardJavaName = this._typeExtensions.getReturnTypeStandardJavaName(method);
        _builder.append(_returnTypeStandardJavaName, " ");
        _builder.append(" ");
        CharSequence _javaMethodName = this.javaMethodName(method);
        _builder.append(_javaMethodName, " ");
        _builder.append("(");
        final Function1<ParamDef, CharSequence> _function_2 = (ParamDef p) -> {
          return this._typeExtensions.javaParam(p, cm);
        };
        String _join_1 = IterableExtensions.<ParamDef>join(this._commonExtensions.getActiveParams(method), ", ", _function_2);
        _builder.append(_join_1, " ");
        _builder.append(") { ");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION ID(static_");
        String _name_1 = method.getName();
        _builder.append(_name_1, "\t");
        _builder.append(") DISABLED START ***/");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        CharSequence _staticMethodBody = this.staticMethodBody(method, m);
        _builder.append(_staticMethodBody, "\t");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION END ***/");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  public CharSequence memberMethodBodies(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/*************************************** ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*\t         Member Methods            * ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("***************************************/");
    _builder.newLine();
    {
      Iterable<Method> _memberMethod = this._typeExtensions.memberMethod(this._commonExtensions.getMethodGroup(cm, m));
      for(final Method method : _memberMethod) {
        final ParamDef thisParam = ((ParamDef[])Conversions.unwrapArray(this._commonExtensions.getActiveParams(method), ParamDef.class))[method.getArg()];
        _builder.newLineIfNotEmpty();
        final Function1<ParamDef, Boolean> _function = (ParamDef p) -> {
          return Boolean.valueOf((!Objects.equal(p, thisParam)));
        };
        final Iterable<ParamDef> usedParams = IterableExtensions.<ParamDef>filter(this._commonExtensions.getActiveParams(method), _function);
        _builder.newLineIfNotEmpty();
        final Function1<ParamDef, Boolean> _function_1 = (ParamDef p) -> {
          return Boolean.valueOf(p.isTake());
        };
        final Iterable<ParamDef> takeList = IterableExtensions.<ParamDef>filter(this._commonExtensions.getActiveParams(method), _function_1);
        _builder.newLineIfNotEmpty();
        _builder.append("/**");
        _builder.newLine();
        _builder.append(" ");
        _builder.append("* ");
        String _name = method.getName();
        _builder.append(_name, " ");
        _builder.append(" ");
        _builder.newLineIfNotEmpty();
        _builder.append(" ");
        _builder.append("* ");
        _builder.newLine();
        {
          boolean _isEmpty = IterableExtensions.isEmpty(takeList);
          boolean _not = (!_isEmpty);
          if (_not) {
            _builder.append(" * @take ");
            final Function1<ParamDef, CharSequence> _function_2 = (ParamDef p) -> {
              String _xifexpression = null;
              boolean _notEquals = (!Objects.equal(p, thisParam));
              if (_notEquals) {
                _xifexpression = p.getName();
              } else {
                _xifexpression = "this";
              }
              return _xifexpression;
            };
            String _join = IterableExtensions.<ParamDef>join(takeList, " ", _function_2);
            _builder.append(_join);
          }
        }
        _builder.newLineIfNotEmpty();
        _builder.append(" ");
        _builder.append("* @generated");
        _builder.newLine();
        _builder.append("**/");
        _builder.newLine();
        String _visibility = this._commonExtensions.visibility(method);
        _builder.append(_visibility);
        _builder.append(" ");
        String _returnTypeStandardJavaName = this._typeExtensions.getReturnTypeStandardJavaName(method);
        _builder.append(_returnTypeStandardJavaName);
        _builder.append(" ");
        CharSequence _javaMethodName = this.javaMethodName(method);
        _builder.append(_javaMethodName);
        _builder.append("(");
        final Function1<ParamDef, CharSequence> _function_3 = (ParamDef p) -> {
          return this._typeExtensions.javaParam(p, cm);
        };
        String _join_1 = IterableExtensions.<ParamDef>join(usedParams, ", ", _function_3);
        _builder.append(_join_1);
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION ID(");
        String _name_1 = method.getName();
        _builder.append(_name_1, "\t");
        _builder.append(") DISABLED START ***/");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        CharSequence _memberMethodBody = this.memberMethodBody(method, thisParam, m);
        _builder.append(_memberMethodBody, "\t");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION END ***/");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence staticMethodBody(final Method method, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("checkParameters(");
    final Function1<ParamDef, Boolean> _function = (ParamDef p) -> {
      return Boolean.valueOf(p.isTake());
    };
    final Function1<ParamDef, CharSequence> _function_1 = (ParamDef p) -> {
      return p.getName();
    };
    String _join = IterableExtensions.<ParamDef>join(IterableExtensions.<ParamDef>filter(this._commonExtensions.getActiveParams(method), _function), ", ", _function_1);
    _builder.append(_join);
    _builder.append(");");
    final String argCheck = _builder.toString();
    StringConcatenation _builder_1 = new StringConcatenation();
    String _ID = this._commonExtensions.ID(m);
    _builder_1.append(_ID);
    _builder_1.append("Native.");
    String _name = method.getName();
    _builder_1.append(_name);
    _builder_1.append("(");
    final Function1<ParamDef, CharSequence> _function_2 = (ParamDef p) -> {
      return this._jNIJavaUtilities.nativeParamStatic(p);
    };
    String _join_1 = IterableExtensions.<ParamDef>join(this._commonExtensions.getActiveParams(method), ", ", _function_2);
    _builder_1.append(_join_1);
    _builder_1.append(")");
    String mainCall = _builder_1.toString();
    if (((this._typeExtensions.getMappingFor(method.getRes()) != null) || this._typeExtensions.isBuiltInTypePointer(method.getRes()))) {
      StringConcatenation _builder_2 = new StringConcatenation();
      String _returnTypeStandardJavaName = this._typeExtensions.getReturnTypeStandardJavaName(method);
      _builder_2.append(_returnTypeStandardJavaName);
      _builder_2.append(".build(");
      _builder_2.append(mainCall);
      _builder_2.append(")");
      mainCall = _builder_2.toString();
    }
    return this.returnExpr(method, argCheck, mainCall, this.objStatusUpdate(method), m);
  }
  
  private CharSequence memberMethodBody(final Method method, final ParamDef thisParam, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("checkParameters(");
    final Function1<ParamDef, Boolean> _function = (ParamDef p) -> {
      return Boolean.valueOf(p.isTake());
    };
    final Function1<ParamDef, CharSequence> _function_1 = (ParamDef p) -> {
      String _xifexpression = null;
      boolean _equals = Objects.equal(p, thisParam);
      if (_equals) {
        _xifexpression = "this";
      } else {
        _xifexpression = p.getName();
      }
      return _xifexpression;
    };
    String _join = IterableExtensions.<ParamDef>join(IterableExtensions.<ParamDef>filter(this._commonExtensions.getActiveParams(method), _function), ", ", _function_1);
    _builder.append(_join);
    _builder.append(");");
    final String argCheck = _builder.toString();
    StringConcatenation _builder_1 = new StringConcatenation();
    String _ID = this._commonExtensions.ID(m);
    _builder_1.append(_ID);
    _builder_1.append("Native.");
    String _name = method.getName();
    _builder_1.append(_name);
    _builder_1.append("(");
    final Function1<ParamDef, CharSequence> _function_2 = (ParamDef p) -> {
      CharSequence _xifexpression = null;
      boolean _equals = Objects.equal(p, thisParam);
      if (_equals) {
        _xifexpression = "getNativePtr(this)";
      } else {
        _xifexpression = this._jNIJavaUtilities.nativeParam(p);
      }
      return _xifexpression;
    };
    String _join_1 = IterableExtensions.<ParamDef>join(this._commonExtensions.getActiveParams(method), ", ", _function_2);
    _builder_1.append(_join_1);
    _builder_1.append(")");
    String mainCall = _builder_1.toString();
    if (((this._typeExtensions.getMappingFor(method.getRes()) != null) || this._typeExtensions.isBuiltInTypePointer(method.getRes()))) {
      StringConcatenation _builder_2 = new StringConcatenation();
      String _returnTypeStandardJavaName = this._typeExtensions.getReturnTypeStandardJavaName(method);
      _builder_2.append(_returnTypeStandardJavaName);
      _builder_2.append(".build(");
      _builder_2.append(mainCall);
      _builder_2.append(")");
      mainCall = _builder_2.toString();
    }
    return this.returnExpr(method, argCheck, mainCall, this.objStatusUpdate(method, thisParam), m);
  }
  
  private CharSequence returnExpr(final Method method, final CharSequence argCheck, final CharSequence mainCall, final CharSequence objStatusUpdate, final Mapping m) {
    CharSequence _xblockexpression = null;
    {
      boolean _isVoid = this._typeExtensions.isVoid(method);
      final boolean hasReturn = (!_isVoid);
      final boolean returnBool = (hasReturn && (method.getRes() instanceof BooleanType));
      String _xifexpression = null;
      if (returnBool) {
        _xifexpression = "boolean res";
      } else {
        String _returnTypeStandardJavaName = this._typeExtensions.getReturnTypeStandardJavaName(method);
        _xifexpression = (_returnTypeStandardJavaName + " res");
      }
      final String res = _xifexpression;
      StringConcatenation _builder = new StringConcatenation();
      {
        if (hasReturn) {
          _builder.append(res);
          _builder.append(";");
          _builder.newLineIfNotEmpty();
        }
      }
      _builder.newLine();
      _builder.append("synchronized(LOCK) {");
      _builder.newLine();
      _builder.append("\t");
      _builder.append(argCheck, "\t");
      _builder.newLineIfNotEmpty();
      _builder.append("\t");
      _builder.append("try {");
      _builder.newLine();
      _builder.append("\t\t");
      {
        if (hasReturn) {
          _builder.append("res = ");
        }
      }
      _builder.append(mainCall, "\t\t");
      {
        if (returnBool) {
          _builder.append(" != 0");
        }
      }
      _builder.append(";");
      _builder.newLineIfNotEmpty();
      _builder.append("\t");
      _builder.append("} finally {");
      _builder.newLine();
      _builder.append("\t\t");
      _builder.append(objStatusUpdate, "\t\t");
      _builder.newLineIfNotEmpty();
      _builder.append("\t");
      _builder.append("}");
      _builder.newLine();
      _builder.append("}");
      _builder.newLine();
      _builder.newLine();
      {
        if (hasReturn) {
          _builder.append("return res;");
          _builder.newLine();
        }
      }
      _xblockexpression = _builder;
    }
    return _xblockexpression;
  }
  
  private CharSequence objStatusUpdate(final Method method) {
    return this.objStatusUpdate(method, null);
  }
  
  private CharSequence objStatusUpdate(final Method method, final ParamDef thisParam) {
    StringConcatenation _builder = new StringConcatenation();
    {
      final Function1<ParamDef, Boolean> _function = (ParamDef p) -> {
        return Boolean.valueOf(p.isTake());
      };
      Iterable<ParamDef> _filter = IterableExtensions.<ParamDef>filter(this._commonExtensions.getActiveParams(method), _function);
      for(final ParamDef param : _filter) {
        {
          boolean _equals = Objects.equal(param, thisParam);
          if (_equals) {
            _builder.append("taken(this);");
            _builder.newLine();
          } else {
            _builder.append("taken(");
            String _name = param.getName();
            _builder.append(_name);
            _builder.append(");");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  public CharSequence toStringBody(final ClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isInterface = this._jNIJavaUtilities.isInterface(cm);
      boolean _not = (!_isInterface);
      if (_not) {
        _builder.append("public String toString() {");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION ID(");
        String _name = cm.getName();
        _builder.append(_name, "\t");
        _builder.append("_toString) DISABLED START ***/");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("return ");
        String _ID = this._commonExtensions.ID(m);
        _builder.append(_ID, "\t\t");
        _builder.append("PrettyPrinter.asString(this);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/*** PROTECTED REGION END ***/");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
}
